#!/usr/local/bin/perl

# comments.cgi
# Copyright 1996, 1997
# Sam Choukri 
# sam@bagism.com
# April 27, 1997

# This script is "freeware", meaning that you can use it and redistribute
# it without payment. However, I have NOT placed this work in the public
# domain. I retain all rights to it. You are NOT permitted to charge
# others for this script. No guarantees or warranties are provided with
# this script. Use at your own risk.
# 
# The following associative arrays define the individual guestbooks. Each
# line within an array should contain two values in single quotes and a
# comma after each value. The first value on the line is a "key" which
# identifies the particular guestbook. The second value is the relevant
# piece of data such as the filename, etc., for that guestbook. To add new
# guestbooks, update all the associative arrays (the end of associative
# arrays are signified below).


# The Names for each of the sites
# -------------------------------
%all_pagetitles = (
'ppm',"Please Please Me",
);



# The paths to the guestbook files containing the comments
# --------------------------------------------------------
%all_pagenames = (
'ppm',"/var/ftpwww/bagism/docs/comments/ppm.html",
);


# The fully qualified URLs to the guestbooks files containing the comments
# ------------------------------------------------------------------------
%all_pageurls = (
'ppm',"http://www.bagism.com/comments/ppm.html",
);


# The BODY tags for each of the sites
# -----------------------------------
%all_body_tags = (
'ppm','<BODY BGCOLOR="#FFFFFF">',
);



# The email addresses of the persons to receive a copy of the entry
# (to send to more than one person, separate with commas)
# -----------------------------------------------------------------
%all_recipients = (
'ppm','sam@bagism.com',
);


# Each site gets its own password to delete entries from ONLY their site.
# There is also a masterpassword defined in the subroutine "InitVars" that
# can be used to delete entries from ANY site. Change any of the passwords
# to whatever you like.
# ------------------------------------------------------------------------
%all_userpasswords = (
'ppm',"nurktwins",
);


#
# That is the end of the associative arrays
#
###########################################

# this tells the script what to do
# --------------------------------
&Main;

sub Main {
	&ReadParse(*input);
	&InitVars;
	if (!$body_tag) { $body_tag = '<BODY>'; }
	
	if ($command eq 'new_comment_form') {
		&NewCommentForm;
	}
	elsif ($command eq 'preview_comment') {
		&CheckInput;
		&PreviewComment;
	}
	elsif ($command eq 'add_comment') {
		&CheckReferer;
		&lock;
		&AddComment;
		&unlock;
		&SendComment;
		&ThankYou;
	}
	elsif (($command eq 'delete_comment_form') || ($command eq '')) {
		&DeleteCommentForm;
	}
	elsif ($command eq 'delete_comment') {
		&lock;
		&DeleteComment;
		&unlock;
	}
	else {
		&PrintMessage('Unknown Command!',
		'You are trying to specify a command that does not exist.');
	}
}



# The only variables you should change here is the mailprog,
# valid_referer, masterpassword, and height and width of the 
# ratings graphics. 
# ---------------------------------------------------------
sub InitVars {
	# you can delete entries from any comments page with this password
	$masterpassword		= "cottonfarmer";

	# the domain name where the script is housed
	# checks when actually adding comments
	$valid_referer		= "bagism.com";

	# the path to the sendmail program
	$mailprog 			= "/usr/sbin/sendmail"; 


	# the height of the ratings graphics 
	# (they must all be the same height)
	$height = "15";
	
	# These are the widths of the graphics for the ratings option.
	# They are listed as pairs of numbers. The first number is the 
	# rating and the second number is the width of the corresponding
	# graphic. For example, a rating of "2.5" would use the graphic
	# "2.5-rating.gif" that is 45 pixels wide.
	%width = (
		"1.0" => "15",
		"1.5" => "30",
		"2.0" => "30",
		"2.5" => "45",
		"3.0" => "45",
		"3.5" => "60",
		"4.0" => "60",
		"4.5" => "75",
		"5.0" => "75",
	);
	

	$date				= `date +"%b %e, %Y"`; chomp $date;
	$script_name		= $ENV{'SCRIPT_NAME'};
	$lock_file			= "$pagename.lock";
	$lock_time			= 8;

	while (($key, $value) = each %input) {
		$$key = $value;
	}

	$body_tag			= $all_body_tags{$code};
	$pagename 			= $all_pagenames{$code};
	$pagetitle 			= $all_pagetitles{$code};
	$pageurl 			= $all_pageurls{$code};
	$userpassword		= $all_userpasswords{$code};
	
	$remote_addr		= $ENV{'REMOTE_ADDR'};
	
	
}




# Subroutine to read comments page into @LINES
# --------------------------------------------
sub ReadPage {
	open (INDEX,"$pagename");
	@LINES=<INDEX>;
	close(INDEX);
}



# Print form for deleting comments
# ---------------------------------
sub DeleteCommentForm {


	&PrintPageHeader('Delete Comment');
	print <<END_OF_HTML;
<H3 ALIGN=CENTER>This allows you to delete Comments by their ID #.</H3>
<HR NOSHADE>
<CENTER>
<FORM METHOD=POST ACTION="$script_name">
<INPUT TYPE=HIDDEN NAME=command VALUE="delete_comment">
<TABLE>
<TR><TD><P><B>Code:</B></TD> <TD><INPUT TYPE=text NAME=code VALUE="$code" SIZE=15></TD></TR>
<TR><TD><P><B>ID #:</B></TD> <TD> <INPUT TYPE=text NAME=id VALUE="$id" SIZE=15></TD></TR>
<TR><TD><P><B>Password:</B></TD> <TD> <INPUT TYPE=password NAME=password SIZE=15></TD></TR>
<TR><TD></TD> <TD> <P><INPUT TYPE=SUBMIT VALUE="Delete Comment"></TD></TR>
</TABLE>
</FORM>
END_OF_HTML

	if (!$code) {
		print "<P><TABLE BORDER=3>\n";
		print "<TR><TH COLSPAN=2>Current Comments Pages</TH></TR>\n";
		print "<TR><TH>Code</TH> <TH>Title</TH></TR>\n";
		while (($key,$value) = each %all_pagetitles) {
			print "<TR><TD>$key</TD> <TD><a href=\"$all_pageurls{$key}\">$value</a></TD></TR>\n";
		}
		print "</TABLE>\n";
	}
		
	print <<END_OF_HTML;
</CENTER>
END_OF_HTML
	&PrintFooter;
	exit(0);
}


# Actually Delete the Comment
# --------------------
sub DeleteComment {
	if (!$code) { 
		&PrintMessage('Comments Page Not Specified!',
		'You did not enter a code for the comments page to work with.');
	}
	if (($password ne $masterpassword) && ($password ne $userpassword)) {
		&PrintMessage('Wrong Password!', 'You did not enter the correct password.');
	}
	if (!$id) { 
		&PrintMessage('Wrong Password!',
		'You did not enter an ID number for the comment to delete.');
	}

	&ReadPage;
	$found = 0;
	open (INDEX,"> $pagename");
	foreach (@LINES) {
		if (/^<!--id=$id-->/io) {
			$found = 1;
		} else {
			print INDEX;
		}
	}
	close(INDEX);
	
	if ($found == 0) {
		&PrintMessage('Error!', 'A comment with that ID number could not be found.');
	} else {
		&PrintMessage('Success!',
		"The comment was deleted successfully.",
		"Go to the <A HREF=\"$pageurl\">$pagetitle</A> page to see the change.");
	}
}




sub NewCommentForm {
	# Initialize the random seed (don't worry about this) 
	srand; 
	# Find a random number between 0 and 9999999.
	# This will form the basis of message id so that we can delete by id.
	$id = int( rand(9999999));


	&PrintPageHeader('Add');
	print <<END_OF_HTML;
<H3 ALIGN=CENTER>Please fill out the information below.</H3>
<HR NOSHADE>
<CENTER>
<FORM METHOD=POST ACTION="$script_name">
<INPUT TYPE=HIDDEN NAME=command VALUE=preview_comment>
<INPUT TYPE=HIDDEN NAME=id VALUE=$id>
END_OF_HTML

	while (($key,$value) = each %input) {
		unless ($key eq 'command') {
			print "<INPUT TYPE=HIDDEN NAME=\"$key\" VALUE=\"$value\">\n";
		}
	}

	print "<P><TABLE BORDER=3>\n"; 

	if ($show =~ /name/) {
		print "<TR><TH ALIGN=LEFT><P>Name:</TH>";
		print "<TD><INPUT NAME=name SIZE=35></TD></TR>\n";
	}
	if ($show =~ /email/) {
		print "<TR><TH ALIGN=LEFT><P>E-mail Address:</TH>";
		print "<TD><INPUT NAME=email SIZE=35> (optional)</TD></TR>\n";
	}
	if ($show =~ /rating/) {
		print <<END_OF_HTML;
<TR>
<TH ALIGN=LEFT><P>Rating:</TH>
<TD>
<SELECT NAME="rating">
<OPTION VALUE="" SELECTED>(make selection)
<OPTION>5.0
<OPTION>4.5
<OPTION>4.0
<OPTION>3.5
<OPTION>3.0
<OPTION>2.5
<OPTION>2.0
<OPTION>1.5
<OPTION>1.0
</SELECT>
(5.0 being the highest)
</TD></TR>
END_OF_HTML
	}

	if ($show =~ /location/) {
		print "<TR><TH ALIGN=LEFT><P>City, State, Country:</TH>";
		print "<TD><INPUT NAME=location SIZE=45> (optional)</TD></TR>\n";
	}

	if ($show =~ /hometitle/) {
		print "<TR><TH ALIGN=LEFT><P>Homepage Name:</TH>";
		print "<TD><INPUT NAME=hometitle SIZE=45> (optional)</TD></TR>\n";
	}

	if ($show =~ /homepage/) {
		print "<TR><TH ALIGN=LEFT><P>Homepage Address:</TH>";
		print "<TD><INPUT NAME=homepage SIZE=45> (optional)</TD></TR>\n";
	}
	if ($show =~ /reference/) {
		print "<TR><TH ALIGN=LEFT><P>Referred By:</TH>";
		print "<TD><INPUT NAME=reference SIZE=45> (optional)</TD></TR>\n";
	}
	if ($show =~ /para/) {
		print "<TR><TH ALIGN=LEFT><P>Where to Add:</TH> <TD><SELECT NAME=para>";
		print "<OPTION VALUE=newpara>In a new paragraph (leaves a blank line)";
		print "<OPTION VALUE=newline>On the next line";
		print "<OPTION VALUE=samepara>At end of current paragraph</SELECT></TD></TR>\n";
	}

	if ($show =~ /comments/) {
	print <<END_OF_HTML; 
<TR>
<TH ALIGN=LEFT COLSPAN=2><P>Your Comments (no HTML markup please):<BR>
<TEXTAREA NAME=comments ROWS=10 COLS=65 WRAP="virtual"></TEXTAREA></TH>
</TR>
END_OF_HTML
	}
	print <<END_OF_HTML; 
<TR><TH COLSPAN=2><P><INPUT TYPE=SUBMIT VALUE="Preview Comment"></TH></TR>
</TABLE>
</FORM>
</CENTER>
END_OF_HTML
	&PrintFooter;
	exit(0);
}

# check the input and print error messages as necessary
# -----------------------------------------------------
sub CheckInput {

	@textinput = ($name, $email, $homepage, $hometitle, $comments);
	
	foreach $textinput (@textinput) {
		if ($textinput =~ /[<>]/) {
			&PrintMessage('Error!', 
			'To prevent the use of HTML tags, the &lt; and &gt; characters are not allowed.');
		}
	}
	
	$name =~ s/^\s+//;
	$name =~ s/\s+$//;
	if ((!$name) && ($require =~ /name/)) {
		&PrintMessage('Error!', 'You did not enter your name.');
	}
	
	$email =~ s/^\s+//;
	$email =~ s/\s+$//;
	if (($email) && ($email =~ /(@.*@)|(\.\.)/ || 
		$email !~ /^.+\@[\w\-\.]+\.[\w]{2,3}$/)) {
			&PrintMessage('Error!', 'Your E-mail address does not appear to be valid.');
	}

	$homepage =~ s/^\s+//;
	$homepage =~ s/\s+$//;
	$homepage = '' if ($homepage eq 'http://');
	if (($homepage) && ($homepage !~ m|^http://[\w\-\.]+\.[\w]{2,3}|)) {
		&PrintMessage('Error!', 'Your Homepage address does not appear to be valid.');
	}
	

	if ((!$rating) && ($require =~ /rating/)) {
		&PrintMessage('Error!', 'You did not select a rating.');
	}

	$hometitle =~ s/^\s+//;
	$hometitle =~ s/\s+$//;
	
	$location =~ s/^\s+//;
	$location =~ s/\s+$//;
	
	$comments =~ s/\n+/ /g;
	$comments =~ s/\r+/ /g;
	$comments =~ s/\"/&quot;/g;
	$comments =~ s/\s+/ /g;
	$comments =~ s/^\s+//;
	$comments =~ s/\s+$//;
	if ((!$comments) && ($require =~ /comments/)) { 
		&PrintMessage('Error!', 'You did not enter a comment.');
	}



}

sub CheckReferer {
	$referer = $ENV{'HTTP_REFERER'};
	if (($referer) && ($referer !~ m|^http://[^/]+\.$valid_referer|)) {
		&PrintMessage('Access Denied!', 
		"$referer<BR> is not recognized as a valid site for access to this script.",
		"Please access the script from the <A HREF=\"$pageurl\">$pagetitle</A> page.");
	}
}


# Add the comment to the guestbook
#--------------------------------
sub PreviewComment {
	&PrintPageHeader('Preview');
	print <<END_OF_HTML; 
<H3 align=CENTER>Your entry will appear as follows. Please double-check it to make sure it says what you want.
If you would like to make changes, go back to the previous page and re-submit the form. If you are satisfied with it, press the button below.</H3>
<HR NOSHADE>
<BLOCKQUOTE>
END_OF_HTML

	print "<!--id=$id-->";
	if ($rating) {
		print "<IMG SRC=\"ratings/$rating.gif\" ALT=\"Rating: $rating\"";
		print " WIDTH=$width{$rating} HEIGHT=$height><BR>";
	}
	if ($options !~ /no_date/) {
		print "<B>$date</B><BR>";
	}
	if ($name) {
		print "<B>$name</B>";
	}
	if ($email) {
		print " (<A HREF=\"mailto:$email\">$email</A>)";
	}
	if ($location) {
		print " from <B>$location</B>";
	}
	if ($options !~ /no_br/) {
		print "<BR>";
	}
	if ($homepage) {
		if (!$hometitle) { $hometitle = $homepage; }
		print "<B>Homepage:</B> <A HREF=\"$homepage\">$hometitle</A><BR>";
	}
	if ($reference) {
		print "<B>Referred By:</B> $reference<BR>";
	}
	if ($comments) {
		if ($options !~ /no_label/) {
			print "<B>Comments:</B> ";
		}
		print "$comments";
	}
    print <<END_OF_HTML;
</BLOCKQUOTE>
<CENTER>
<FORM METHOD=POST ACTION="$script_name">
<INPUT TYPE=HIDDEN NAME="command" VALUE="add_comment">
<INPUT TYPE=HIDDEN NAME="comments" VALUE="$comments">
END_OF_HTML

	while (($key,$value) = each %input) {
		unless (($key eq 'command') || ($key eq 'comments')) {
			print "<INPUT TYPE=HIDDEN NAME=\"$key\" VALUE=\"$value\">\n";
		}
	}

	print <<END_OF_HTML; 
<INPUT TYPE="submit" VALUE="Add Comment">
</FORM>
</CENTER>
END_OF_HTML
	&PrintFooter;
	exit(0);
}


# Add the comment to the guestbook
#--------------------------------
sub AddComment {

	&ReadPage;
	open (COMMENTS,"> $pagename");

	if ($options =~ /add_to_top/) {$where = "TOP";} else { $where = "BOTTOM"; }
	foreach (@LINES) {
		if (/^<!--$where-->/io) {
			if ($where eq 'TOP') {
				print COMMENTS "<!--TOP-->\n";
			}
			
			print COMMENTS "<!--id=$id-->";
			if ((!$para) || ($para eq 'newpara')) {
				print COMMENTS "<P>";
			}
			elsif ($para eq 'newline') {
				print COMMENTS "<BR>";		
			}
			if ($rating) {
				print COMMENTS "<IMG SRC=\"ratings/$rating.gif\" ALT=\"Rating: $rating\" ";
				print COMMENTS "WIDTH=$width{$rating} HEIGHT=$height><BR>";
			}
			if ($options !~ /no_date/) {
				print COMMENTS "<B>$date</B><BR>";
			}
			if ($name) {
				print COMMENTS "<B>$name</B>";
			}
			if ($email) {
				print COMMENTS " (<A HREF=\"mailto:$email\">$email</A>)";
			}
			if ($location) {
				print COMMENTS " from <B>$location</B>";
			}
			if ($options !~ /no_br/) {
				print COMMENTS "<BR>";
			}
			if ($homepage) {
				if (!$hometitle) { $hometitle = $homepage; }
				print COMMENTS "<B>Homepage:</B> <A HREF=\"$homepage\">$hometitle</A><BR>";
			}
			if ($reference) {
				print COMMENTS "<B>Referred By:</B> $reference<BR>";
			}
			if ($comments) {
				if ($options !~ /no_label/) {
					print COMMENTS "<B>Comments:</B> ";
				}
				print COMMENTS "$comments";
			}
			print COMMENTS "<!--addr=$remote_addr-->";
			if ($options =~ /no_hr/) {
				print COMMENTS " \n";
			}
			else {
				print COMMENTS "<HR NOSHADE WIDTH=\"75%\">\n";
			}
			
			if ($where eq 'BOTTOM') {
				print COMMENTS "<!--BOTTOM-->\n";
			}
		} elsif (/^<!--id=$id-->/o) {
			$duplicate = 1; 
		} elsif (/^Last Update:/) {
			print COMMENTS "Last Update: $date\n";
		} else {
			print COMMENTS;
		}
	}
	close(COMMENTS);
	
	if ($duplicate == 1) {
		&PrintMessage('Duplicate Found!', 
		'Your message has replaced the previous one submitted with the same ID number.',
		"RELOAD the <A HREF=\"$pageurl\">$pagetitle</A> page to see your message.");
	}

}




# Send a copy of the comment by e-mail
#-------------------------------------
sub SendComment {
	@recipients	= split(/,/, $all_recipients{$code});

	if (!$name) { $name = "Anonymous"; }
	if (!$email) { $email = "nobody\@nobody.com"; }
	

	foreach $recipient (@recipients) {
		open (MAIL, "|$mailprog -t") || die "Can't open $mailprog!\n";
		print MAIL <<END_OF_TEXT; 
From: $name <$email>
To: $recipient
Subject: Comment Added to $pagetitle
X-remote-address: $remote_addr

Below is a comment added to the $pagetitle

To delete the entry, go to the following URL:
http://$ENV{'SERVER_NAME'}$script_name?code=$code&id=$id
-------------------------------------------------------------------------
END_OF_TEXT
		
		if ($hometitle) { print MAIL "Homepage Title: $hometitle\n"; }
		if ($homepage) { print MAIL "Homepage URL: $homepage\n"; }
		if ($location) { print MAIL "Location: $location\n";}
		if ($reference) { print MAIL "Referred By: $reference\n\n";}
		if ($rating) { print MAIL "Rating: $rating\n\n";}
		print MAIL "$comments\n";
		close(MAIL);
	}

}

sub ThankYou {
	&PrintMessage('Thank You!', 
	"Your comments have been added to the <A HREF=\"$pageurl\">$pagetitle</A> page.",
	'You may need to RELOAD the page before you can see your comment.');
}

sub PrintPageHeader {
	local($title) = @_;
	print "Content-type: text/html\n\n";
	print <<END_OF_HTML;
<HTML>
<HEAD><TITLE>$title</TITLE>
<BASE HREF="$pageurl">
</HEAD>

$body_tag

<CENTER>
<H1>$title</H1>
</CENTER>
<BLOCKQUOTE>
<HR NOSHADE>
END_OF_HTML
}

sub PrintFooter {
	print <<END_OF_HTML;
</BLOCKQUOTE>
<P>
<CENTER>
<HR NOSHADE SIZE=1 WIDTH="50%">
<SMALL>
Original programming by <A HREF="mailto:sam\@bagism.com">Sam Choukri</A>
for <A HREF="http://www.bagism.com/">Bagism</A>
</SMALL> 
<HR NOSHADE SIZE=1 WIDTH="50%">
</CENTER>
</BODY>
</HTML>
END_OF_HTML

	exit;

}



sub PrintMessage {
    local ($title, $message, $message2) = @_;
    if (!$message2) {
    	$message2 = "Use your browser\'s Back button to go back and fix the problem."
    }

	&PrintPageHeader($title);
	print "<H3 ALIGN=CENTER>$title</H3>\n<H3>$message $message2</H3>\n";
	&PrintFooter;
	exit(0);
}


sub lock {

   $time = time();
   $quit = 0;
   LOCK: while ($quit != 1) {
      if (-e "$lock_file") {
         if ($time + $lock_time < time()) {
         	last LOCK;
         }
         else {
           sleep(1);
         }
      }
      else {
         open(LOCK_FILE,">$lock_file");
         close LOCK_FILE;
         last LOCK;
      }
   }
}


sub unlock {
   unlink $lock_file;
   $quit = 1;
}


# (from cgi-lib.pl)
# Copyright 1994 Steven E. Brenner
# Unpublished work.
# Permission granted to use and modify this library so long as the
# copyright above is maintained, modifications are documented, and
# credit is given for any use of the library.
# Thanks are due to many people for reporting bugs and suggestions
# especially Meng Weng Wong, Maki Watanabe, Bo Frese Rasmussen,
# Andrew Dalke, Mark-Jason Dominus and Dave Dittrich.
sub MethGet { return ($ENV{'REQUEST_METHOD'} eq "GET"); }
sub ReadParse {  local (*in) = @_ if @_;
  local ($i, $loc, $key, $val);
  if ($ENV{'REQUEST_METHOD'} eq "GET") { $in = $ENV{'QUERY_STRING'}; } 
  elsif ($ENV{'REQUEST_METHOD'} eq "POST") { 
      read(STDIN,$in,$ENV{'CONTENT_LENGTH'});}
  @in = split(/&/,$in);
  foreach $i (0 .. $#in) {
    $in[$i] =~ s/\+/ /g;
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;
    $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;
  }
  return 1; # just for fun
}
